<template>
  <div
    v-if="hasControls"
    @click="onClickDisplayParametersDialog"
    class="row items-center cursor-pointer"
  >
    <q-icon
      name="las la-cogs"
      color="grey"
      size="xs"
    />
    <div class="text-grey text-caption q-ml-xs">
      <translate>Display settings</translate>
    </div>
  </div>
</template>

<script>
import algorithms from 'src/services/fieldbook/fertilization/algorithms'
import FertilizationResultDisplaySettingsDialog from 'src/pages/fieldbook/fertilization/algorithms/common/components/FertilizationResultDisplaySettingsDialog'

export default {
  name: 'FertilizationResultDisplaySettingsButton',
  props: {
    algorithmId: {
      type: String,
      required: true
    },
    hideDisplayPKAsOxydeControl: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      showDialog: false,
      showResultAfterFertilization: false
    }
  },
  computed: {
    hasControls () {
      return this.showPKDisplayControl
    },
    showPKDisplayControl () {
      return !this.hideDisplayPKAsOxydeControl && this.checkControlSupport('pkDisplay')
    }
  },
  methods: {
    checkControlSupport (controlName) {
      const algoConfig = algorithms[this.algorithmId]
      return Boolean(algoConfig.controls?.[controlName])
    },
    onClickDisplayParametersDialog () {
      this.$q.dialog({
        component: FertilizationResultDisplaySettingsDialog,
        componentProps: {
          showPKDisplayControl: this.showPKDisplayControl,
          showBeforeAfterFertilizationControl: false
        }
      })
    }
  }
}
</script>
